## libpappsomspp 0.11.10

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

# CMake script for PAPPSOms++ library
# Authors: Olivier Langella & Filippo Rusconi
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)

############################################################
############################################################
# Basic information about project

project(libpappsomspp)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(PAPPSOMSPP_VERSION_MAJOR "0")
set(PAPPSOMSPP_VERSION_MINOR "11")
set(PAPPSOMSPP_VERSION_PATCH "10")
set(PAPPSOMSPP_VERSION "${PAPPSOMSPP_VERSION_MAJOR}.${PAPPSOMSPP_VERSION_MINOR}.${PAPPSOMSPP_VERSION_PATCH}")
set(MASSCHROQ_VERSION "3.0.2")

# Command to enable debug and tests
# cmake -DCMAKE_BUILD_TYPE=Debug  -DMAKE_TESTS=1 -DUSEPAPPSOTREE=0 ..

message(STATUS "${BoldYellow}CMAKE_LIBRARY_ARCHITECTURE: ${CMAKE_LIBRARY_ARCHITECTURE}${ColourReset}")

# This line MUST be located prior to include'ing GNUInstallDirs !!!
#############################################################
#############################################################
# Installation prefix
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX
        "/usr/local"
        CACHE PATH "Install path" FORCE
    )
else()
    set(CMAKE_INSTALL_PREFIX
        "${CMAKE_INSTALL_PREFIX}"
        CACHE PATH "Install path" FORCE
    )
endif()

include(GNUInstallDirs)

message(STATUS "Set CMAKE_INSTALL_PREFIX to ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Install directory prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "CMAKE_INSTALL_FULL_LIBDIR: ${CMAKE_INSTALL_FULL_LIBDIR}")
message(STATUS "CMAKE_INSTALL_FULL_INCLUDEDIR: ${CMAKE_INSTALL_FULL_INCLUDEDIR}")

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)

configure_file(${CMAKE_UTILS_PATH}/version.cmake.in ${CMAKE_BINARY_DIR}/version.txt)

# We need a variable that is not modified by CMake because we'll need to access
# that specific directory later
set(LOCAL_CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)
message("CMakeLists.txt - LOCAL_CMAKE_MODULE_PATH:" ${LOCAL_CMAKE_MODULE_PATH})

# Now add our local path to the general path list.
set(CMAKE_MODULE_PATH ${LOCAL_CMAKE_MODULE_PATH} ${CMAKE_MODULE_PATH})

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN10UCRT64 if SYSTEM_UNAME_S is "MSYS_NT-10.0-*"
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldGreen}Configuring build for project ${PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json")
    execute_process(
        COMMAND cmake -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
                ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()

# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)
# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall.${ColourReset}")
add_definitions(-Wall)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
    message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
    add_definitions(-Werror)
endif()

message(STATUS "${BoldYellow}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")

option(MXE "Use the cross-compiling environment MXE" OFF)

#############################################################
#############################################################
# Platform-specific CMake configuration
if(MXE)
    # Run the following cmake command line:
    # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-$ENV{USER}.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

elseif(UNIX AND NOT APPLE)
    # Run the following cmake command line:
    # cmake -DBUILD_USER_MANUAL=1 -DCMAKE_BUILD_TYPE=Debug

    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)
    #include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)

elseif(WIN32 OR _WIN32)

    if(WIN10UCRT64)
        include(${CMAKE_TOOLCHAINS_PATH}/win10-ucrt64-toolchain.cmake)
    endif()

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")

#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

# Gee, do not set that to default!
# set(MAKE_TESTS 1)

option(MAKE_TESTS Off)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE
        Release
        CACHE STRING "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel." FORCE
    )
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
    message(STATUS "Compiling in release mode.")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
    message(STATUS "Compiling in debug mode with MAKE_TESTS: ${MAKE_TESTS}.")
    message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
    add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    message(STATUS "Compiling in release with debug info mode.")
endif(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")

# PWIZLITE
if(NOT PwizLite_FOUND)
    message(STATUS "PwizLite not yet found. Searching for it.")
    find_package(PwizLite REQUIRED)
endif()
message(STATUS "PwizLite_INCLUDE_DIRS: ${PwizLite_INCLUDE_DIRS}")
message(STATUS "PwizLite_LIBRARIES: ${PwizLite_LIBRARIES}")

# BOOST
if(NOT Boost_FOUND)
    message(STATUS "Boost not yet found. Searching for it.")
    find_package(
        Boost
        COMPONENTS iostreams thread filesystem chrono
        REQUIRED
    )
endif()
message(STATUS "Boost_LIBRARIES found ${Boost_LIB_VERSION}")
message(STATUS "Boost_INCLUDES: ${Boost_INCLUDE_DIRS}")
message(STATUS "Boost_LIB_DIRS: ${Boost_LIBRARY_DIRS}")

# QCustomPlotQt6
if(QCustomPlotQt6_FOUND)

else(QCustomPlotQt6_FOUND)
    set(QCustomPlotQt6_DIR ${CMAKE_MODULE_PATH})
    find_package(QCustomPlotQt6 REQUIRED)
endif(QCustomPlotQt6_FOUND)

message(STATUS "CMakeLists.txt - CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")

if(Zstd_FOUND)

else(Zstd_FOUND)
    set(Zstd_DIR ${CMAKE_MODULE_PATH})
    find_package(Zstd REQUIRED)
endif(Zstd_FOUND)

if(SQLite3_FOUND)

else(SQLite3_FOUND)
    set(SQLite3_DIR ${CMAKE_MODULE_PATH})
    find_package(SQLite3 REQUIRED)
endif(SQLite3_FOUND)

if(NOT USEPAPPSOTREE)
    set(USEPAPPSOTREE 0)
endif(NOT USEPAPPSOTREE)

option(PROFILING Off)
if(PROFILING)
    message(STATUS "${BoldYellow}Profiling is requested, adding -pg -g flags.${ColourReset}")
    add_definitions(-pg -g)
endif()

# Subdirectories
#generate Doxyfile even if doxygen is not configured
configure_file(${CMAKE_SOURCE_DIR}/doc/Doxyfile.in ${CMAKE_BINARY_DIR}/doc/Doxyfile @ONLY)
message(STATUS "Adding subdirectory doc for ${PROJECT_NAME}")
add_subdirectory(doc)

message(STATUS "Adding subdirectory src for ${PROJECT_NAME}")
add_subdirectory(src)

# Doxygen
if(UNIX AND NOT APPLE)
    find_package(Doxygen)

    if(DOXYGEN_FOUND)

        add_custom_target(
            apidoc
            cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-build
            COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-build
            COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-build
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        )

        add_custom_target(
            apidoc-stable
            cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-stable
            COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
            COMMAND echo "HTML_HEADER=header.html" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
            COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-stable
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        )

    endif(DOXYGEN_FOUND)

endif(UNIX AND NOT APPLE)

#############################################################
###########################
# CREATE THE SOURCE PACKAGE
include(${CMAKE_UTILS_PATH}/targz-source-package-creation.cmake)

add_custom_target(
    archive
    cpack
    -G
    TGZ
    --config
    CPackSourceConfig.cmake
    &&
    mv
    ${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}-${PAPPSOMSPP_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../tarballs
    &&
    ln
    -sf
    ${CMAKE_SOURCE_DIR}/../tarballs/${CMAKE_PROJECT_NAME}-${PAPPSOMSPP_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../${CMAKE_PROJECT_NAME}_${PAPPSOMSPP_VERSION}.orig.tar.gz
    &&
    ln
    -sf
    ${CMAKE_SOURCE_DIR}/../tarballs/${CMAKE_PROJECT_NAME}-${PAPPSOMSPP_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../tarballs/${CMAKE_PROJECT_NAME}_${PAPPSOMSPP_VERSION}.orig.tar.gz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating .tar.gz"
    VERBATIM
)

# Packager
set(CPACK_PACKAGE_NAME "libpappsomspp")
set(CPACK_PACKAGE_VENDOR "PAPPSO Development Team")
set(CPACK_PACKAGE_VERSION "${PAPPSOMSPP_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "${PAPPSOMSPP_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${PAPPSOMSPP_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${PAPPSOMSPP_VERSION_PATCH}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The PAPPSO C++ library for mass spectrometry")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
set(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES
    \\\\.git/
    "CMakeFiles"
    "Makefile"
    "_CPack_Packages"
    "CMakeCache.txt"
    ".*\\\\.gz"
    ".*\\\\.deb"
    ".*\\\\.rpm"
    ".*\\\\.dmg"
    ".*\\\\..*\\\\.swp"
    "src/\\\\..*"
    "src/libbpp*"
    "debian/tmp"
    "debian/libbpp.*/"
    "debian/libbpp.*\\\\.so.*"
    "debian/libbpp.*\\\\.a"
    "debian/libbpp.*\\\\.substvars"
    "debian/libbpp.*\\\\.debhelper"
    "debian/debhelper\\\\.log"
    "html"
    "Core.tag"
    "Testing"
    "build/"
    "cbuild/"
    "dbuild/"
    "wbuild/"
    "buildwin64/"
    ".zed/"
    "build-stamp"
    "install_manifest.txt"
    "DartConfiguration.tcl"
    ${CPACK_SOURCE_IGNORE_FILES}
    ".cache"
    "Session.vim"
    "compile_commands.json"
    ".kdev4"
    "*.kdev4"
)

#dch -Dstretch "message"
#cmake ..
#make deb
# scp libpappsomspp* proteus.ideev.universite-paris-saclay.fr:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default
# apt-get remove libpappsomspp*
#
#  debuild -S -sa
# dput -f olivier-langella *changes

#dpkg-deb -x libpappsomspp-qt4_0.0.4-1_amd64.deb libpappsomspp-qt4_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt4 -Plibpappsomspp-qt4_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt4.symbols

#dpkg-deb -x libpappsomspp-qt5_0.0.4-1_amd64.deb libpappsomspp-qt5_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt5 -Plibpappsomspp-qt5_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt5.symbols

if(MACOS)
    set(CPACK_GENERATOR "Bundle")
endif()

=== src/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)
# Major rework of the whole project structure, Filippo Rusconi, summer 2025

message("\n${BoldGreen}Now configuring src/ for ${PROJECT_NAME}${ColourReset}\n")

# We need this subdirectory because we want to  be able to access all the headers
# using #include <pappsomspp/...> when developing software that uses this
# library and that we want to use it in its development location, not  as
# an installed library.
message("Addding subdirectory pappsomspp for ${PROJECT_NAME}")

add_subdirectory(pappsomspp)

add_subdirectory(cli)

message("\n${BoldGreen}Done configuring src/ for ${PROJECT_NAME}${ColourReset}\n")

=== tests/CMakeLists.txt ===
if(MAKE_TESTS AND (WIN64 OR (UNIX AND NOT APPLE)))

    set(CMAKE_CXX_FLAGS "-Wno-error=deprecated-declarations")

    message("${BoldGreen}\nNow configuring tests for ${CMAKE_PROJECT_NAME}\n${ColourReset}")

    # CMake script for PAPPSOms++ library
    # Authors: Copyright Olivier Langella & Filippo Rusconi
    # GPLv3+
    # Created: 03/03/2015 from the CMakeLists file of the Bio++ project
    # Changes 20201201 by FR.

    if(USE_PAPPSO_TREE)
        set(USEPAPPSOTREE 1)
        message("USEPAPPSOTREE is defined")
        message("Please be sure that your environment has accessed to the PAPPSO directory")
    endif(USE_PAPPSO_TREE)

    configure_file(${CMAKE_UTILS_PATH}/tests-config.h.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/tests-config.h)
    
    #apt-get install libpwiz-dev libboost-dev
    #CTEST_OUTPUT_ON_FAILURE=TRUE make test
    #make test ARGS="-V"
    #make test ARGS="-V -I 4,4"

    #export LD_LIBRARY_PATH=/home/langella/developpement/git/pappsomspp/build/src:$LD_LIBRARY_PATH

    #set(CMAKE_MODULE_PATH "/usr/share/cmake-3.0/Modules")

    message("tests/CMakeLists.txt - CMAKE_MODULE_PATH:" ${CMAKE_MODULE_PATH})

    find_package(Catch2 REQUIRED)
    find_package(
        Boost
        COMPONENTS chrono
        REQUIRED
    )

    if(OdsStream_FOUND)

    else(OdsStream_FOUND)
        find_package(OdsStream REQUIRED)
    endif(OdsStream_FOUND)

    if(TARGET OdsStream::Core)
        message("OdsStream::Core found.")
    else(TARGET OdsStream::Core)
        message("OdsStream::Core not found.")
    endif(TARGET OdsStream::Core)

    # When running tests we necessarily have to document the location of the
    # libraries that were built locally.
    set(PappsoMSpp_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/src")
    set(PappsoMSpp_LIBRARY "${CMAKE_BINARY_DIR}/src/pappsomspp/core/libpappsomspp-core.so")
    set(PappsoMSppWidget_LIBRARY "${CMAKE_BINARY_DIR}/src/pappsomspp/gui/libpappsomspp-gui.so")

    message("In tests, include dirs for pappsomspp: ${PappsoMSpp_INCLUDE_DIRS}")
    message("In tests, core library: ${PappsoMSpp_LIBRARY}")
    message("In tests, widget library: ${PappsoMSppWidget_LIBRARY}")

    # These source files are compiled into a single Catch2-based test binary.
    set(catch2_only_cpp_SRCS
        catch-only-tests-main.cpp
        test_aa.cpp
        test_aacode.cpp
        test_big_hyperscore.cpp
        test_cborpsmmap.cpp
        test_datapoint.cpp
        test_fasta_reader.cpp
        test_fragmentationcid.cpp
        test_hyperscore.cpp
        test_isotope_with_spectrum.cpp
        test_trace.cpp
        test_maptrace.cpp
        test_massrange.cpp
        test_tracecombiner.cpp
        test_massspectrum.cpp
        test_mzintegrationparams.cpp
        test_massspectrumcombiner.cpp
        test_mzcbor.cpp
        test_trace_filters.cpp
        test_xic.cpp
        test_proforma.cpp
        test_project.cpp
        test_protein.cpp
        test_proteincode.cpp
        test_peptide.cpp
        test_peptidefragment.cpp
        test_peptidenaturalisotopelist.cpp
        test_natural_isotope_average.cpp
        test_psm.cpp
        test_msrunoutput.cpp
        test_uimonitor.cpp
        test_rawmasslist.cpp
        test_spectree.cpp
        test_timsframe.cpp
        test_tandem_run_wrapper.cpp
        test_unimod.cpp
        test_scan_15968.cpp
        test_c13n15.cpp
        test_xtandem_spectrum.cpp
        saxparsers/xtandemresultshandler.cpp
    )

    # These source files are compiled into a single Catch2-based test binary.
    # tests dedicated to check memory usage and avoid memory leaks
    set(catch2_only_cpp_memory_SRCS memory/test_tandemwrapperrun.cpp memory/test_timsdata_reader_memory.cpp)

    add_executable(catch2-only-memory ${catch2_only_cpp_memory_SRCS} common.cpp)

    add_executable(catch2-only-tests ${catch2_only_cpp_SRCS} common.cpp)

    add_custom_target(
        catch2-tests
        catch2-only-tests
        DEPENDS catch2-only-tests
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMENT "Running the Catch2-based tests."
    )

    set_property(TARGET catch2-only-tests PROPERTY CXX_STANDARD 17) # we want C++17

    message("CMAKE_BINARY_DIR ${CMAKE_BINARY_DIR}")
    message("CMAKE_CURRENT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}")

    target_include_directories(
        catch2-only-tests
        PUBLIC ${CMAKE_BINARY_DIR} # so that #include "config.h" works and #include "tests/tests-config.h" works also
               ${PappsoMSpp_INCLUDE_DIRS}
               Catch2::Catch2
               Catch2::Catch2WithMain
    )

    get_target_property(INCLUDE_DIRS catch2-only-tests INTERFACE_INCLUDE_DIRECTORIES)
    message("Include directories for catch2-only-tests: ${INCLUDE_DIRS}")

    target_include_directories(
        catch2-only-memory
        PUBLIC ${CMAKE_BINARY_DIR} # so that #include "config.h" works
               ${PappsoMSpp_INCLUDE_DIRS}
               Catch2::Catch2
               Catch2::Catch2WithMain
    )

    set(required_target_link_libraries
        Core
        Catch2::Catch2
        Catch2::Catch2WithMain
        OdsStream::Core
        liblzf::liblzf
        QuaZip::QuaZip
        OdsStream::Core
    )

    target_link_libraries(catch2-only-tests ${required_target_link_libraries})

    target_link_libraries(catch2-only-memory ${required_target_link_libraries})

    # Add the Catch2-based single binary test file to the CMake's test suite so
    # that it gets called using 'make test'. To see the output, add "ARGS=-V" to
    # the call.
    add_test(catch2-only-tests "catch2-only-tests")

    set_property(TEST catch2-only-tests PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=${CMAKE_BINARY_PATH}/src")

    if(WIN32)
        set(ENV{PATH} "$ENV{PATH};..\\src")
    endif()

    #add_subdirectory(widget)

    add_subdirectory(benchmarks)
    add_subdirectory(proteincode)
    add_subdirectory(peptidoms)
    add_subdirectory(dia)
    if(USE_PAPPSO_TREE)
        add_subdirectory(pappsotree)
    endif()
    message(\n${BoldGreen}"Done configuring tests for ${CMAKE_PROJECT_NAME}"${ColourReset}\n)

else()
    message(STATUS "Tests are not built.")
endif()

=== doc/js_qml/CMakeLists.txt ===
message("\n${BoldGreen}Now configuring src/doc/js_qml for ${PROJECT_NAME}${ColourReset}\n")

################ JavaScript reference text handling #################
################ JavaScript reference text handling #################

find_package(Python3 REQUIRED)

############ List all the files that contain the class JS reference tag
# that is like so:
# /* BEGIN CLASS JS REFERENCE
# * namespace: pappso
# * class name: MzIntegrationParams
# */
# The jsExtract.py program lists the files to stdout and that output
# is redirected to OUTPUT_FILE.

set(TOP_JS_REF_DIR ${CMAKE_CURRENT_SOURCE_DIR}/js_reference/)
set(SCRIPTS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/scripts)

set(CORE_SRC_DIR ${CMAKE_SOURCE_DIR}/src/pappsomspp/core)
set(GUI_SRC_DIR ${CMAKE_SOURCE_DIR}/src/pappsomspp/gui)

set(CORE_OUTPUT_DIR ${TOP_JS_REF_DIR}/Core)
set(GUI_OUTPUT_DIR ${TOP_JS_REF_DIR}/Gui)

set(CORE_CLASS_JS_REF_FILE_LIST ${CMAKE_CURRENT_BINARY_DIR}/core_class_js_reference_file_list.txt)
set(CORE_CLASS_JS_REF_TEXT ${CORE_OUTPUT_DIR}/class_js_reference_text.txt)

set(GUI_CLASS_JS_REF_FILE_LIST ${CMAKE_CURRENT_BINARY_DIR}/gui_class_js_reference_file_list.txt)
set(GUI_CLASS_JS_REF_TEXT ${GUI_OUTPUT_DIR}/class_js_reference_text.txt)

# When run (see add_custom_target(list_class_js_ref_files below)
# this command will list all the header files in the Core lib that have
# a class JS reference text in them.
add_custom_command(
    OUTPUT ${CORE_CLASS_JS_REF_FILE_LIST}
    COMMAND ${Python3_EXECUTABLE} ${SCRIPTS_DIR}/jsExtract.py --list-files class -d ${CORE_SRC_DIR} -t "  " >
            ${CORE_CLASS_JS_REF_FILE_LIST}
    COMMENT "List Core files containing class JS reference text"
    VERBATIM
)

# When run (see add_custom_target(list_class_js_ref_files below)
# this command will list all the header files in the Widget lib that have
# a class JS reference text in them.
add_custom_command(
    OUTPUT ${GUI_CLASS_JS_REF_FILE_LIST}
    COMMAND ${Python3_EXECUTABLE} ${SCRIPTS_DIR}/jsExtract.py --list-files class -d ${GUI_SRC_DIR} -t "  " >
            ${GUI_CLASS_JS_REF_FILE_LIST}
    COMMENT "List Widget files containing class JS reference text"
    VERBATIM
)

# Runs the commands above that create the files listed here as DEPENDS
add_custom_target(
    list_class_js_ref_files
    DEPENDS ${CORE_CLASS_JS_REF_FILE_LIST} ${GUI_CLASS_JS_REF_FILE_LIST}
    COMMENT "Listing Core and Widget files containing class JS reference text"
)

# When run (see add_custom_target(extract_class_js_ref_text below)
# this command will extract from the files listed in the lists generated above
# all the class JS reference text.
#
# Core
add_custom_command(
    OUTPUT ${CORE_CLASS_JS_REF_TEXT}
    DEPENDS ${CORE_CLASS_JS_REF_FILE_LIST}
    COMMAND ${Python3_EXECUTABLE} ${SCRIPTS_DIR}/jsExtract.py --tab "  " --extract class --listfile
            ${CORE_CLASS_JS_REF_FILE_LIST} > ${CORE_CLASS_JS_REF_TEXT}
    COMMENT "Extract class JS reference text from Core header files"
    VERBATIM
)
#
# Widget
add_custom_command(
    OUTPUT ${GUI_CLASS_JS_REF_TEXT}
    DEPENDS ${GUI_CLASS_JS_REF_FILE_LIST}
    COMMAND ${Python3_EXECUTABLE} ${SCRIPTS_DIR}/jsExtract.py --tab "  " --extract class --listfile
            ${GUI_CLASS_JS_REF_FILE_LIST} > ${GUI_CLASS_JS_REF_TEXT}
    COMMENT "Extract class JS reference text from Widget header files"
    VERBATIM
)

# Runs the commands above that create the files listed here as DEPENDS
add_custom_target(
    extract_class_js_ref_text
    DEPENDS ${CORE_CLASS_JS_REF_TEXT} ${GUI_CLASS_JS_REF_TEXT}
    COMMENT "Extracting class JavaScript reference text"
)

message("\n${BoldGreen}Done configuring src/doc/js_qml for ${PROJECT_NAME}${ColourReset}\n")

=== doc/typst/CMakeLists.txt ===
if(USE_TYPST)
    set(USETYPST_DEFAULT_ALL_TARGET ON)

    message("\n${BoldGreen}Build typst documentation ${PROJECT_NAME}${ColourReset}\n")
    include(${LOCAL_CMAKE_MODULE_PATH}/UseTYPST.cmake)
    add_typst_document(psmcbor_documentation psmcbor/psmcbordoc.typ)
    add_typst_document(masschroq_documentation mcq/main.typ)
    add_typst_document(mzcbor_documentation mzcbor/mzcbordoc.typ)
endif(USE_TYPST)

=== src/cli/CMakeLists.txt ===
message("\n${BoldGreen}Now configuring src/cli for ${PROJECT_NAME}${ColourReset}\n")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

########################## mzml2mzcbor ##########################
add_executable(
    mzml2mzcbor
    mzml2mzcborcli.cpp
)

target_include_directories(
    mzml2mzcbor
    PUBLIC ${PappsoMSpp_INCLUDE_DIRS}
)

target_link_libraries(
    mzml2mzcbor Qt6::Core Qt6::Qml Core
)

add_dependencies(mzml2mzcbor Core)


########################## mzcbor2mzml ##########################

add_executable(
    mzcbor2mzml
    mzcbor2mzmlcli.cpp
)

target_include_directories(
    mzcbor2mzml
    PUBLIC ${PappsoMSpp_INCLUDE_DIRS}
)

target_link_libraries(
    mzcbor2mzml Qt6::Core Qt6::Qml Core
)

add_dependencies(mzcbor2mzml Core)

########################## sage2psmcborcli ##########################

add_executable(
    sage2psmcbor
    sage2psmcborcli.cpp
)

target_include_directories(
    sage2psmcbor
    PUBLIC ${PappsoMSpp_INCLUDE_DIRS}
)

target_link_libraries(
    sage2psmcbor Qt6::Core Qt6::Qml Core
)

########################## mzcbor-spectrum2json ##########################

add_executable(
    mzcbor-spectrum2json
    mzcborspectrum2jsoncli.cpp
)

target_include_directories(
    mzcbor-spectrum2json
    PUBLIC ${PappsoMSpp_INCLUDE_DIRS}
)

target_link_libraries(
    mzcbor-spectrum2json Qt6::Core Qt6::Qml Core
)

add_dependencies(mzcbor-spectrum2json Core)


########################## Install CLI tools ##########################
#
install(
    PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/mzml2mzcbor
    DESTINATION bin
)


install(
    PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/mzcbor2mzml
    DESTINATION bin
)


install(
    PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/sage2psmcbor
    DESTINATION bin
)
install(
    PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/mzcbor-spectrum2json
    DESTINATION bin
)
########################## The man page ##########################

if(UNIX AND NOT APPLE)

    find_program(rst2man_program rst2man)
    if(NOT rst2man_program)
        message(FATAL_ERROR "rst2man not found!")
    endif()

    set(mzml2mzcbor_manpage ${CMAKE_CURRENT_BINARY_DIR}/mzml2mzcbor.1)

    add_custom_command(
        OUTPUT ${mzml2mzcbor_manpage}
        COMMAND ${rst2man_program} ${CMAKE_CURRENT_SOURCE_DIR}/mzml2mzcbor.1.rst ${mzml2mzcbor_manpage}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/mzml2mzcbor.1.rst
        COMMENT "Generating man page mzml2mzcbor.1 from mzml2mzcbor.rst"
        VERBATIM
    )


    set(mzcbor2mzml_manpage ${CMAKE_CURRENT_BINARY_DIR}/mzcbor2mzml.1)
    add_custom_command(
        OUTPUT ${mzcbor2mzml_manpage}
        COMMAND ${rst2man_program} ${CMAKE_CURRENT_SOURCE_DIR}/mzcbor2mzml.1.rst ${mzcbor2mzml_manpage}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/mzcbor2mzml.1.rst
        COMMENT "Generating man page mzcbor2mzml.1 from mzcbor2mzml.rst"
        VERBATIM
    )

    set(sage2psmcbor_manpage ${CMAKE_CURRENT_BINARY_DIR}/sage2psmcbor.1)
    add_custom_command(
        OUTPUT ${sage2psmcbor_manpage}
        COMMAND ${rst2man_program} ${CMAKE_CURRENT_SOURCE_DIR}/sage2psmcbor.1.rst ${sage2psmcbor_manpage}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/sage2psmcbor.1.rst
        COMMENT "Generating man page sage2psmcbor.1 from sage2psmcbor.rst"
        VERBATIM
    )
    ########################## mzcbor-spectrum2json generate man page ##########################
    set(mzcbor-spectrum2json_manpage ${CMAKE_CURRENT_BINARY_DIR}/mzcbor-spectrum2json.1)
    add_custom_command(
        OUTPUT ${mzcbor-spectrum2json_manpage}
        COMMAND ${rst2man_program} ${CMAKE_CURRENT_SOURCE_DIR}/mzcbor-spectrum2json.1.rst ${mzcbor-spectrum2json_manpage}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/mzcbor-spectrum2json.1.rst
        COMMENT "Generating man page v.1 from mzcbor-spectrum2json.rst"
        VERBATIM
    )

    # define manpage target
    add_custom_target(manpage ALL DEPENDS ${mzml2mzcbor_manpage} ${mzcbor2mzml_manpage} ${sage2psmcbor_manpage} ${mzcbor-spectrum2json_manpage} )

    # Install the generated file
    install(
        FILES ${mzml2mzcbor_manpage} ${mzcbor2mzml_manpage} ${sage2psmcbor_manpage} ${mzcbor-spectrum2json_manpage}
        DESTINATION share/man/man1
    )

endif()

message("\n${BoldGreen}Done configuring src/cli for ${PROJECT_NAME}${ColourReset}\n")

=== tests/pappsotree/CMakeLists.txt ===


# These source files are compiled into a single Catch2-based test binary.
# tests dedicated to check speed performances (benchmarks)
set(catch2_only_cpp_pappsotree_SRCS
    test_cborpsm.cpp
    test_cborpsm2json.cpp
    test_cbormzid.cpp
    test_cborsage.cpp
    test_fasta_reader.cpp
    test_msrun.cpp
    test_msrunalignment.cpp
    test_msrunreaderng_tims.cpp
    test_msrunreaderng.cpp
    test_mzcbor.cpp
    test_tims_dda.cpp
    test_tims_dia.cpp
   # test_tims_dia_micro.cpp
   # test_tims_dia_micro_slice.cpp
   # test_tims_dia_nano.cpp
    test_tims_data_xic_chromatogram.cpp
    test_tims_ion_mobility_grid.cpp
    test_mzcbor_xicextractor.cpp
    test_timsframe.cpp
    test_xicextractor.cpp
  )

add_executable(catch2-only-pappsotree
    ../common.cpp
    ${catch2_only_cpp_pappsotree_SRCS}
  )

get_target_property(INCLUDE_DIRS catch2-only-pappsotree INTERFACE_INCLUDE_DIRECTORIES)
message("Include directories for catch2-only-pappsotree: ${INCLUDE_DIRS}")


target_link_libraries(catch2-only-pappsotree
    ${required_target_link_libraries})


target_include_directories(catch2-only-pappsotree PUBLIC
      ${CMAKE_BINARY_DIR}/tests

    ${CMAKE_BINARY_DIR} # so that #include "config.h" works and #include "tests/tests-config.h" works also
    ${PappsoMSpp_INCLUDE_DIRS}
    Catch2::Catch2
    Catch2::Catch2WithMain
    )

=== tests/peptidoms/CMakeLists.txt ===
# These source files are compiled into a single Catch2-based test binary.
# tests dedicated to check speed performances (benchmarks)
set(catch2_only_cpp_peptidoms_SRCS  test_peptidoms.cpp test_fine_4291.cpp test_zea_4291.cpp test_zea_8119.cpp test_diff_java.cpp)

if(USE_PAPPSO_TREE)
    set(catch2_only_cpp_peptidoms_pappsotree_SRCS test_double.cpp test_precise_align.cpp test_zea_4512.cpp test_zea_4542.cpp)
endif(USE_PAPPSO_TREE)

add_executable(
    catch2-only-peptidoms
    ${catch2_only_cpp_peptidoms_SRCS} ${catch2_only_cpp_peptidoms_pappsotree_SRCS} ../common.cpp
)

get_target_property(INCLUDE_DIRS catch2-only-peptidoms INTERFACE_INCLUDE_DIRECTORIES)
message("Include directories for catch2-only-peptidoms: ${INCLUDE_DIRS}")

target_include_directories(
    catch2-only-peptidoms
    PUBLIC
    ${CMAKE_BINARY_DIR} # so that #include "config.h" works and #include "tests/tests-config.h" works also
    ${PappsoMSpp_INCLUDE_DIRS}
    Catch2::Catch2
    Catch2::Catch2WithMain
)

target_link_libraries(
    catch2-only-peptidoms ${required_target_link_libraries}
)

=== src/pappsomspp/core/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)
# Major rework of the whole project structure, Filippo Rusconi, summer 2025

message("\n${BoldGreen}Now configuring src/core for ${PROJECT_NAME}${ColourReset}\n")

add_definitions(-DWITHOUT_MZ5)

########################################################
# Files
set(CPP_FILES
    types.cpp
    utils.cpp
    mzrange.cpp
    precision.cpp
    amino_acid/aa.cpp
    amino_acid/aabase.cpp
    amino_acid/aacode.cpp
    amino_acid/aamodification.cpp
    amino_acid/aastringcodec.cpp
    amino_acid/aastringcodemassmatching.cpp
    amino_acid/atomnumberinterface.cpp
    amino_acid/chemicalformula.cpp
    massspectrum/massspectrumid.cpp
    massspectrum/massspectrum.cpp
    massspectrum/qualifiedmassspectrum.cpp
    fasta/fastafileindexer.cpp
    fasta/fastareader.cpp
    fasta/fastaoutputstream.cpp
    grouping/grpexperiment.cpp
    grouping/grppeptide.cpp
    grouping/grpprotein.cpp
    grouping/grpgroup.cpp
    grouping/grpsubgroup.cpp
    grouping/grppeptideset.cpp
    grouping/grpmappeptidetogroup.cpp
    grouping/grpmappeptidetosubgroupset.cpp
    grouping/grpsubgroupset.cpp
    grouping/grpgroupingmonitor.cpp
    masschroq/input/jsoninput.cpp
    masschroq/input/precursorparser.cpp
    masschroq/output/cboroutputstream.cpp
    masschroq/alignmentmethod.cpp
    masschroq/mbrpeptidemeasurements.cpp
    masschroq/msrun.cpp
    masschroq/msrungroup.cpp
    masschroq/msrunpeptidelist.cpp
    masschroq/peptide.cpp
    masschroq/peptidebase.cpp
    masschroq/peptidelabel.cpp
    masschroq/peptidemeasurements.cpp
    masschroq/peptidemeasurementsbase.cpp
    masschroq/peptideobservation.cpp
    masschroq/precursor.cpp
    masschroq/protein.cpp
    masschroq/quantificationmethod.cpp
    masschroq/utils.cpp
    msfile/msfileaccessor.cpp
    msfile/msfilereader.cpp
    msfile/mzcbormsfilereader.cpp
    msfile/mzformatenumstr.cpp
    msfile/pwizmsfilereader.cpp
    msfile/timsmsfilereader.cpp
    msfile/xymsfilereader.cpp
    msfile/bafasciifilereader.cpp
    msrun/spectrumcollectionhandlerinterface.cpp
    msrun/alignment/msrunretentiontime.cpp
    msrun/alignment/template.cpp
    msrun/output/mzxmloutput.cpp
    msrun/output/mgfoutput.cpp
    msrun/msrundatasettreenode.cpp
    msrun/msrundatasettree.cpp
    msrun/msrunid.cpp
    msrun/msrunreader.cpp
    msrun/msrunreadconfig.cpp
    msrun/private/mzcbormsrunreader.cpp
    msrun/private/pwizmsrunreader.cpp
    msrun/private/timsmsrunreader.cpp
    msrun/private/timsmsrunreaderbase.cpp
    msrun/private/timsmsrunreaderdia.cpp
    msrun/private/timsframesmsrunreader.cpp
    msrun/private/timsmsrunreaderms2.cpp
    msrun/private/timsmsrunreaderms2selected.cpp
    msrun/xiccoord/ionmobilitygrid.cpp
    msrun/xiccoord/xiccoord.cpp
    msrun/xiccoord/xiccoordtims.cpp
    msrun/xymsrunreader.cpp
    msrun/bafasciimsrunreader.cpp
    obo/filterobopsimodmap.cpp
    obo/filterobopsimodsink.cpp
    obo/filterobopsimodtermaccession.cpp
    obo/filterobopsimodtermdiffmono.cpp
    obo/filterobopsimodtermlabel.cpp
    obo/filterobopsimodtermname.cpp
    obo/obopsimod.cpp
    obo/obopsimodterm.cpp
    obo/obopsims.cpp
    obo/obounimod.cpp
    peptide/ion.cpp
    peptide/peptideinterface.cpp
    peptide/peptide.cpp
    peptide/peptidefragment.cpp
    peptide/peptidefragmention.cpp
    peptide/peptidefragmentionlistbase.cpp
    peptide/peptidenaturalisotope.cpp
    peptide/peptidenaturalisotopelist.cpp
    peptide/peptidenaturalisotopeaverage.cpp
    peptide/peptideproformaparser.cpp
    peptide/peptiderawfragmentmasses.cpp
    peptide/peptidestrparser.cpp
    processing/cbor/cborstreamreader.cpp
    processing/cbor/cborstreamreaderinterface.cpp
    processing/cbor/cborstreamwriter.cpp
    processing/cbor/jsonstreamwriter.cpp
    processing/cbor/mzcbor/binarydataarray.cpp
    processing/cbor/mzcbor/converttomzml.cpp
    processing/cbor/mzcbor/cvparam.cpp
    processing/cbor/mzcbor/cvparammap.cpp
    processing/cbor/mzcbor/mzcborbuildindexreader.cpp
    processing/cbor/mzcbor/mzcborindexreader.cpp
    processing/cbor/mzcbor/mzcborspectrumcollectionreader.cpp
    processing/cbor/mzcbor/mzcborreaderbase.cpp
    processing/cbor/mzcbor/mzmlconvert.cpp
    processing/cbor/mzcbor/precursor.cpp
    processing/cbor/mzcbor/scan.cpp
    processing/cbor/mzcbor/spectrum.cpp
    processing/cbor/psm/cborscanmapbase.cpp
    processing/cbor/psm/psmcbor2json.cpp
    processing/cbor/psm/psmcborutils.cpp
    processing/cbor/psm/psmfileappend.cpp
    processing/cbor/psm/psmfilereaderbase.cpp
    processing/cbor/psm/psmfilescanprocess.cpp
    processing/cbor/psm/psmfilescanprocessandcopy.cpp
    processing/cbor/psm/psmproteinmap.cpp
    processing/cbor/psm/evalscan/psmfeatures.cpp
    processing/cbor/psm/evalscan/psmfeaturesscan.cpp
    processing/cbor/psm/evalscan/psmionseries.cpp
    processing/cbor/psm/evalscan/psmspecglob.cpp
    processing/cbor/psm/evalscan/psmspecglobscan.cpp
    processing/cbor/psm/evalscan/psmspecpeptidoms.cpp
    processing/cbor/psm/mzidentml/mzidentmlreader.cpp
    processing/cbor/psm/sage/sagefilereader.cpp
    processing/cbor/psm/sage/sagereader.cpp
    processing/cbor/psm/sage/sagetsvhandler.cpp
    processing/combiners/mzintegrationparams.cpp
    processing/combiners/integrationscopebase.cpp
    processing/combiners/integrationscope.cpp
    processing/combiners/integrationscoperect.cpp
    processing/combiners/integrationscoperhomb.cpp
    processing/combiners/selectionpolygon.cpp
    processing/combiners/tracecombiner.cpp
    processing/combiners/traceminuscombiner.cpp
    processing/combiners/tracepluscombiner.cpp
    processing/combiners/massdatacombinerinterface.cpp
    processing/combiners/massspectrumcombiner.cpp
    processing/combiners/massspectrumpluscombiner.cpp
    processing/combiners/massspectrumminuscombiner.cpp
    processing/compartraces/cosinesimilarity.cpp
    processing/detection/tracedetectionzivy.cpp
    processing/detection/tracedetectionmoulon.cpp
    processing/detection/tracepeak.cpp
    processing/detection/tracepeaklist.cpp
    processing/detection/cubicsplinemodel.cpp
    processing/detection/localsignaltonoiseestimator.cpp
    processing/detection/highrespeakpicker.cpp
    processing/filters/filterchargedeconvolution.cpp
    processing/filters/filtercomplementionenhancer.cpp
    processing/filters/filterexclusionmz.cpp
    processing/filters/filterlocalmaximum.cpp
    processing/filters/filtermorpho.cpp
    processing/filters/filternameinterface.cpp
    processing/filters/filterpass.cpp
    processing/filters/filterpeakdelta.cpp
    processing/filters/filterremovec13.cpp
    processing/filters/filterresample.cpp
    processing/filters/filtersuite.cpp
    processing/filters/filtersuitestring.cpp
    processing/filters/filtertandemremovec13.cpp
    processing/filters/filtertriangle.cpp
    processing/filters/savgolfilter.cpp
    processing/filters/filterflooramplitudepercentage.cpp
    processing/filters/filterceilingamplitudepercentage.cpp
    processing/filters/filterlowintensitysignalremoval.cpp
    processing/filters/filternormalizeintensities.cpp
    processing/project/projectparameters.cpp
    processing/specglob/experimentalspectrum.cpp
    processing/specglob/peptidemodel.cpp
    processing/specglob/peptidespectrum.cpp
    processing/specglob/posttreatment.cpp
    processing/specglob/scorevalues.cpp
    processing/specglob/spectralalignment.cpp
    processing/specpeptidoms/correctiontree.cpp
    processing/specpeptidoms/locationsaver.cpp
    processing/specpeptidoms/peptidemodel.cpp
    processing/specpeptidoms/scenario.cpp
    processing/specpeptidoms/scorevalues.cpp
    processing/specpeptidoms/semiglobalalignment.cpp
    processing/specpeptidoms/spomsprotein.cpp
    processing/specpeptidoms/spomsspectrum.cpp
    processing/specself/selfspectrum.cpp
    processing/specself/selfspectrumdatapoint.cpp
    processing/spectree/bucket.cpp
    processing/spectree/bucketclustering.cpp
    processing/spectree/itemcart.cpp
    processing/spectree/spectree.cpp
    processing/spectree/specxtractinterface.cpp
    processing/tandemwrapper/tandemwrapperrun.cpp
    processing/tandemwrapper/wraptandeminput.cpp
    processing/tandemwrapper/wraptandemresults.cpp
    processing/tandemwrapper/xtandempresetreader.cpp
    processing/uimonitor/uimonitortext.cpp
    processing/uimonitor/uimonitortextpercent.cpp
    processing/xml/mzidentmlwriter.cpp
    processing/xml/xmlstreamreaderinterface.cpp
    protein/enzyme.cpp
    protein/peptidesizefilter.cpp
    protein/peptidebuilder.cpp
    protein/peptidevariablemodificationbuilder.cpp
    protein/peptidevariablemodificationreplacement.cpp
    protein/peptidefixedmodificationbuilder.cpp
    protein/peptidemodificatorbase.cpp
    protein/peptidemodificatortee.cpp
    protein/peptidemethioninremove.cpp
    protein/peptidemodificatorpipeline.cpp
    protein/peptidesemienzyme.cpp
    protein/protein.cpp
    protein/proteinintegercode.cpp
    protein/proteinpresenceabsencematrix.cpp
    psm/deepprot/deepprotenum.cpp
    psm/experimental/ionisotoperatioscore.cpp
    psm/features/psmfeatures.cpp
    psm/morpheus/morpheusscore.cpp
    psm/peakionmatch.cpp
    psm/peakionisotopematch.cpp
    psm/peptidespectrummatch.cpp
    psm/peptideisotopespectrummatch.cpp
    psm/xtandem/xtandemhyperscore.cpp
    psm/xtandem/xtandemhyperscorebis.cpp
    psm/xtandem/xtandemspectrumprocess.cpp
    trace/datapoint.cpp
    trace/linearregression.cpp
    trace/maptrace.cpp
    trace/trace.cpp
    vendors/tims/mobilitytraces/timsframemobilitytraces.cpp
    vendors/tims/mzcalibration/cardano.cpp
    vendors/tims/mzcalibration/mzcalibrationinterface.cpp
    vendors/tims/mzcalibration/mzcalibrationmodel1.cpp
    vendors/tims/mzcalibration/mzcalibrationstore.cpp
    vendors/tims/xicextractor/timsdirectxicextractor.cpp
    vendors/tims/xicextractor/timsxicextractorinterface.cpp
    vendors/tims/timsbindec.cpp
    vendors/tims/timsdata.cpp
    vendors/tims/timsdatafastmap.cpp
    vendors/tims/timsddaprecursors.cpp
    vendors/tims/timsdiaslices.cpp
    vendors/tims/timsframe.cpp
    vendors/tims/timsframerawdatachunck.cpp
    vendors/tims/timsframebase.cpp
    vendors/tims/timsframetype1.cpp
    vendors/tims/timsms2centroidfilter.cpp
    xic/xic.cpp
    xic/qualifiedxic.cpp
    xic/xicpeptideinterface.cpp
    xic/xicpeptidefragmention.cpp
    xic/xicpeptidefragmentionnaturalisotope.cpp
    xicextractor/private/msrunslice.cpp
    xicextractor/private/msrunxicextractor.cpp
    xicextractor/private/msrunxicextractordisk.cpp
    xicextractor/private/msrunxicextractordiskbuffer.cpp
    xicextractor/msrunxicextractorfactory.cpp
    xicextractor/msrunxicextractorinterface.cpp
    #
    # Scripting
    js_qml/jsclassregistrar.cpp
    js_qml/pappsojsqml.cpp
    js_qml/datapointjs.cpp
    js_qml/qpointfjs.cpp
    js_qml/tracejs.cpp
    js_qml/massspectrumjs.cpp
)

# generate rules for building source files from the resources
# and the JS reference text also.
qt6_add_resources(QRC_SRCS libpappsomspp_core_resources.qrc)

message("Generated the following resource files: ${QRC_SRCS}")

file(
    GLOB_RECURSE Core_HEADERS
    LIST_DIRECTORIES false
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    "*.h"
)
message(STATUS "Core header files: ${Core_HEADERS}")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

#############################################################
# Build the static lib
add_library(
    Core_static STATIC
    ${Core_HEADERS} ${CPP_FILES} ${QRC_SRCS}
)

# So that the JavaScript reference text is extracted before using
# libpappsomspp_core_resources.qrc that reference it.
add_dependencies(Core_static extract_class_js_ref_text)

set_target_properties(
    Core_static
    PROPERTIES EXPORT_NAME "Core_static"
               OUTPUT_NAME pappsomspp-core
               CLEAN_DIRECT_OUTPUT 1
               LINK_FLAGS "-Wl,--whole-archive"
)

=== debian/changelog ===
libpappsomspp (0.11.10-1) unstable; urgency=medium

  [Rusconi]
  * New upstream release with new code to estimate noise and pick peaks.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 17 Feb 2026 14:56:28 +0100

=== debian/control ===
Source: libpappsomspp
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-exec,
 cmake,
 d-shlibs,
 libxkbcommon-x11-dev,
 qt6-base-dev,
 qt6-declarative-dev,
 libqt6core5compat6-dev,
 libqt6svg6-dev,
 qt6-documentation-tools,
 libpwizlite-dev (>= 3.0.11),
 libqcustomplot-dev (>= 2.1.0),
 libodsstream-dev (>= 0.9.15),
 libsqlite3-dev,
 libzstd-dev,
 liblzf-dev,
 zlib1g-dev,
 libquazip1-qt6-dev,
 libboost1.88-dev,
 libboost-chrono1.88-dev,
 libboost-system1.88-dev,
 libboost-container1.88-dev,
 libboost-filesystem1.88-dev,
 libboost-thread1.88-dev,
 libboost-iostreams1.88-dev,
 libboost-random1.88-dev,
 doxygen,
 catch2,
# for rst2man
 python3-docutils
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debichem-team/libpappsomspp
Vcs-Git: https://salsa.debian.org/debichem-team/libpappsomspp.git
Homepage: http://pappso.inrae.fr/bioinfo


Package: libpappsomspp-core0
Architecture: any
Multi-Arch: same
Conflicts: libpappsomspp0
Breaks: libpappsomspp0
Replaces: libpappsomspp0
Depends: libqt6sql6-sqlite,
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++ library to handle mass spectrometry data (non-GUI runtime)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the non-GUI library.


Package: libpappsomspp-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-dev
Depends: libpappsomspp-core0 (= ${binary:Version}),
 ${misc:Depends}
Recommends: libpappsomspp-doc
Description: C++ library to handle mass spectrometry data (development files)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the development files for the non-GUI library.


Package: libpappsomspp-gui0
Architecture: any
Multi-Arch: same
Conflicts: libpappsomspp-widget0
Breaks: libpappsomspp-widget0
Replaces: libpappsomspp-widget0
Depends: libpappsomspp-core0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library to handle mass spectrometry data (GUI runtime)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the GUI library.


Package: libpappsomspp-gui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-widget-dev
Depends: libpappsomspp-gui0 (= ${binary:Version}),
         libpappsomspp-core-dev (= ${binary:Version}),
         ${misc:Depends}
Recommends: libpappsomspp-doc
Description: C++ library to handle mass spectrometry data (GUI development files)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the development files for the GUI library.


Package: libpappsomspp-cli
Section: science
Architecture: any
Depends: ${shlibs:Depends},
				 ${misc:Depends},
				 libpappsomspp-core0
Multi-Arch: same
Replaces: libpappsomspp-cli
Recommends: libpappsomspp-doc
Description: C++ library to handle mass spectrometry data (GUI development files)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships command line interface programs.


Package: libpappsomspp-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: C++ library to handle mass spectrometry data (developer documentation)
 libpappsomspp provides a simple API to perform a variety of
 tasks related to mass spectrometry. Although the library is
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package contains the developer documentation.
